﻿//Calkowanie numerczyne - metoda Simpsona
//(c) 2012 by Tomasz Lubinski
//www.algorytm.org

//fun - string - function (for exaple "x*x + 3")
//x - float - x value
function funValue(fun, x)
{
	return eval(fun);
}

//fun - string - function to integrate (for exaple "x*x + 3")
//xp - float - start of the range to integrate
//xk - float - end of the range to integrate
//n - integer - precision
function calculate(fun, xp, xk, n)
{
	//width of the one interval
	var dx = (xk - xp) / n;

	//initialize result
	var result = 0;

	var s = 0;
	for (var i=1; i<n; i++) 
	{
		var x = xp + i*dx;
		s += funValue(fun, x - dx / 2);
		result += funValue(fun, x);
	}
	s += funValue(fun, xk - dx / 2);
	result = (dx/6) * (funValue(fun, xp) + funValue(fun, xk) + 2*result + 4*s);

	//return result
	return result;
}
